@echo off
rem -------------------------------------------------------------------------
rem BCD, Build CD-Rom
rem Copyright (c) 2002 Bart Lagerweij. All rights reserved.
rem This program is free software. Use and/or distribute it under the terms
rem of the NU2 License (see nu2lic.txt or http://www.nu2.nu/license/).
rem -------------------------------------------------------------------------
rem Traduction des textes affichs par Sverin TERRIER
echo.
echo BCD, Build CD-Rom, v1.1.1
echo Copyright (c) 2002 Bart Lagerweij. All rights reserved.
echo This program is free software. Use and/or distribute it under the terms
echo of the NU2 License (see nu2lic.txt or http://www.nu2.nu/license/).
echo.
verify other 2>nul
setlocal enableextensions
if errorlevel 1 goto _noext
if not "%_4VER%" == "" goto _4nt
rem to current drive and path
%~d0
cd "%~dp0"
if "%1" == "" goto _usage
echo BCD : Vrification des fichiers ncessaires :
for %%i in (bin\bchoice.exe bin\cdrecord.exe bin\cygwin1.dll bin\mkisofs.exe) do if not exist %%i (
	echo BCD : Fichier "%%i" introuvable.
	goto _abort)
set bcd_name=
set bcd_deb=
set bcd_noburn=
set bcd_spd=
set bcd_cmd=
set bcd_arg=
set bcd_boot=
set bcd_volid=
set bcd_vset=
set bcd_prep=
set bcd_publ=
set bcd_appid=
set bcd_sysid=
set bcd_isofs=
set bcd_cdr=
set bcd_isofs=
set bcd_tmp=
set bcd_dev=
set bcd_call=
set bcd_src=
set bcd_err=
if exist %temp%\$bcd$.tm? del %temp%\$bcd$.tm?
:_arg
if "%1" == "" goto _start
if "%1" == "-d" goto _deb
if "%1" == "-b" goto _noburn
if "%1" == "-s" goto _speed
if "%1" == "-bab" goto _bldall
if "%bcd_name%" == "" goto _name
:_next
shift
goto _arg
:_deb
set bcd_deb=1
goto _next
:_noburn
set bcd_noburn=1
goto _next
:_speed
shift
set bcd_spd=%1
if "%bcd_spd%" GTR "50" (
	echo BCD : Ignore une vitesse invalide "%bcd_spd%", doit tre entre 1-50.
	set bcd_spd=
	goto _next)
if "%bcd_spd%" LSS "1" (
	echo BCD : Ignore une vitesse invalide "%bcd_spd%", doit tre entre 1-50.
	set bcd_spd=)
echo BCD : Vitesse rgle  "%bcd_spd%"
goto _next
:_name
set bcd_name=%1
goto _next
:_start
if not exist cds\%bcd_name%\nul goto _nodir
:_cfgredo
if exist bcd.cfg goto _cfgok
	if exist bcd.sam (
		echo BCD : Renommage de bcd.sam en bcd.cfg
		ren bcd.sam bcd.cfg
		goto _cfgredo)
	echo BCD : Impossible de trouver bcd.cfg
:_cfgok
echo BCD : Traitement du fichier de configuration principal "bcd.cfg"
for /f "eol=# tokens=1*" %%i in (bcd.cfg) do (
	set bcd_cmd=%%i
	set bcd_arg=%%j
	call :_bline)
if not "%bcd_err%" == "" goto _abort
if not exist cds\%bcd_name%\bcd.cfg goto _nocfg
echo BCD : Traitement du fichier de configuration du CD "cds\%bcd_name%\bcd.cfg"
for /f "eol=# tokens=1*" %%i in (cds\%bcd_name%\bcd.cfg) do (
	set bcd_cmd=%%i
	set bcd_arg=%%j
	call :_bline)
if not "%bcd_err%" == "" goto _abort
:_nocfg
rem
if "%bcd_isofs%" == "" (
	echo BCD : Pas d'options pour mkisofs, ajout de "-J -N"
	set bcd_isofs=-J -N)
if not "%bcd_volid%" == "" set bcd_isofs=%bcd_isofs% -volid "%bcd_volid%"
if not "%bcd_prep%" == "" set bcd_isofs=%bcd_isofs% -p "%bcd_prep%"
if not "%bcd_publ%" == "" set bcd_isofs=%bcd_isofs% -P "%bcd_publ%"
if not "%bcd_appid%" == "" set bcd_isofs=%bcd_isofs% -A %bcd_appid%
if not "%bcd_sysid%" == "" set bcd_isofs=%bcd_isofs% -sysid "%bcd_sysid%"
if not "%bcd_vset%" == "" set bcd_isofs=%bcd_isofs% -volset "%bcd_vset%"

rem process bootdisk.cfg file
if not exist cds\%bcd_name%\bootdisk.cfg goto _bdcfg
echo BCD : Traitement du fichier de configuration du bootdisk "cds\%bcd_name%\bootdisk.cfg"
set rv=
for /f "eol=# tokens=1,2" %%i in (cds\%bcd_name%\bootdisk.cfg) do call :_bflop %%i %%j
if not "%bcd_err%" == "" goto _abort
:_bdcfg

rem call some "custom" script
if "%bcd_call%" == "" goto _norun0
if not exist cds\%bcd_name%\%bcd_call% goto _norun0
echo BCD : Appelle le fichier batch personnalis "cds\%bcd_name%\%bcd_call%"
call cds\%bcd_name%\%bcd_call%
if "%rv%" == "1" goto _abort
:_norun0

if "%bcd_boot%" == "" goto _noboot
rem replace bootfile '\' with '/'
set bcd_boot=%bcd_boot:\=/%
echo BCD : Le fichier de boot est "%bcd_boot%"
set bcd_tmp=cds\%bcd_name%\files\%bcd_boot%
if not exist %bcd_tmp% (
	echo BCD : Le fichier de boot "%bcd_tmp%" est introuvable
	goto _abort)
set bcd_isofs=%bcd_isofs% -b %bcd_boot%
for %%i in (%bcd_tmp%) do if "%%~xi" == ".bin" (
	echo BCD : Secteur de boot de type ".bin" ajout de "-no-emul-boot -boot-load-size 4"
	set bcd_isofs=%bcd_isofs% -no-emul-boot -boot-load-size 4)
for %%i in (%bcd_tmp%) do if "%%~nxi" == "isolinux.bin" (
	echo BCD : Secteur de boot de type ISOLINUX ajout de "-boot-info-table"
	set bcd_isofs=%bcd_isofs% -boot-info-table)
for %%i in (%bcd_tmp%) do if not "%%~xi" == ".bin" goto _nont
findstr /I "setupldr.bin" %bcd_tmp% > %temp%\$bcd$.tmp 2>&1
for /f %%j in (%temp%\$bcd$.tmp) do goto _nont
	echo BCD : Secteur de boot de type NT ajout de "-no-iso-translate -relaxed-filenames"
	set bcd_isofs=%bcd_isofs% -no-iso-translate -relaxed-filenames
:_nont
for %%i in (%bcd_tmp%) do (
	set bcd_isofs=%bcd_isofs% -hide %%~nxi
	echo BCD : Masquage de l'image de boot en ISO9660 ajout de "-hide %%~nxi")
echo BCD : Masquage du catalogue de boot en ISO9660 ajout de "-hide boot.catalog"
set bcd_isofs=%bcd_isofs% -hide boot.catalog
echo %bcd_isofs% > %temp%\$bcd$.tm2
findstr "/C:-J " %temp%\$bcd$.tm2 > %temp%\$bcd$.tmp 2>&1
for /f %%i in (%temp%\$bcd$.tmp) do goto _joliet
goto _nojol
:_joliet
	for %%i in (%bcd_tmp%) do (
		echo BCD : Masquage de l'image de boot en Joliet ajout de "-hide-joliet %%~nxi"
		set bcd_isofs=%bcd_isofs% -hide-joliet %%~nxi)
	echo BCD : Masquage du catalogue de boot en Joliet ajout de "-hide-joliet boot.catalog"
	set bcd_isofs=%bcd_isofs% -hide-joliet boot.catalog
:_nojol
:_noboot
:_norun1
echo BCD : Cration de l'image ISO (lancement de mkisofs.exe)
echo BCD : Arguments; %bcd_isofs% -v -o %temp%\bcd.iso cds\%bcd_name%\files %bcd_pth%
bin\mkisofs.exe %bcd_isofs% -v -o %temp%\bcd.iso cds\%bcd_name%\files %bcd_pth%
if errorlevel 1 (
	echo BCD : mkisofs.exe a retourn une erreur...
	goto _abort)
echo BCD : Fichier ISO "%temp%\bcd.iso" cr.
if not "%bcd_noburn%" == "" goto _end
if exist bin\wnaspi32.dll goto _wnaspok
echo BCD : Fichier "bin\wnaspi32.dll" manquant, merci de le tlcharger depuis
echo BCD : http://www.nero.com/en/download.htm et le placer dans le dossier "bin".
echo BCD : Ce fichier est ncessaire pour accder au graveur.
set bcd_noburn=1
goto _end
:_wnaspok
set bcd_dev=
echo BCD : Recherche des priphriques, lancement de "cdrecord -scanbus":
bin\cdrecord.exe -scanbus > %temp%\$bcd$.tmp 2>&1
if errorlevel 1 (
	echo BCD : "cdrecord -scanbus" a retourn une erreur ! Gravure impossible !
	set bcd_noburn=1
	goto _end)
findstr /I "/C:cd-rom" %temp%\$bcd$.tmp > %temp%\$bcd$.tm2
for /f %%i in (%temp%\$bcd$.tm2) do goto _devfnd
echo BCD : Aucun priphrique trouv ! Gravure impossible !
set bcd_noburn=1
goto _end
:_devfnd
echo BCD : Priphriques trouvs :
type %temp%\$bcd$.tm2
set bcd_dev=
echo BCD : Recherche d'un graveur de CD rinscriptible :
for /f "delims=	" %%i in (%temp%\$bcd$.tm2) do (
	set bcd_tmp=%%i
	call :_chkdev Does write CD-RW media)
if not "%bcd_dev%" == "" goto _devok
echo BCD : Recherche d'un graveur de CD :
for /f "delims=	" %%i in (%temp%\$bcd$.tm2) do (
	set bcd_tmp=%%i
	call :_chkdev Does write CD-R media)
if not "%bcd_dev%" == "" goto _devok
echo BCD : Recherche d'un graveur de DVD-RAM :
for /f "delims=	" %%i in (%temp%\$bcd$.tm2) do (
	set bcd_tmp=%%i
	call :_chkdev Does write DVD-R media)
if not "%bcd_dev%" == "" goto _devok
echo BCD : Recherche d'un graveur de DVD-R :
for /f "delims=	" %%i in (%temp%\$bcd$.tm2) do (
	set bcd_tmp=%%i
	call :_chkdev Does write DVD-RAM media)
if not "%bcd_dev%" == "" goto _devok
if "%bcd_dev%" == "" (
	echo BCD : Aucun graveur trouv ! Gravure impossible !
	set bcd_noburn=1
	goto _end)
:_devok
echo BCD : Graveur trouv  "%bcd_dev%".
if "%bcd_cdr%" == "" (
	echo BCD : Pas d'option pour cdrecord, ajout de "-data -eject"
	set bcd_cdr=-data -eject)
echo BCD : Vrification des options spcifiques au pilote
echo BCD : Lance "cdrecord.exe dev=%bcd_dev% -checkdrive driveropts=help"
bin\cdrecord.exe dev=%bcd_dev% -checkdrive driveropts=help >%temp%\$bcd$.tmp 2>&1
if errorlevel 1 goto _media
findstr /I /B "burnfree " %temp%\$bcd$.tmp >%temp%\$bcd$.tm2
for /f %%i in (%temp%\$bcd$.tm2) do goto _burnfree
goto _media
:_burnfree
echo BCD : Le graveur supporte burnfree, ajout de "driveropts=burnfree"
set bcd_cdr=%bcd_cdr% driveropts=burnfree
:_media
echo BCD : Chargement du CD
bin\cdrecord.exe dev=%bcd_dev% -load >nul 2>&1
if errorlevel 1 goto _nomedia
echo BCD : Vrification du type de CD
bin\cdrecord.exe dev=%bcd_dev% -atip >%temp%\$bcd$.tmp 2>&1
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	type %temp%\$bcd$.tmp
	goto _abort)
findstr /I "/C:No disk / Wrong disk!" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
for /f %%j in (%temp%\$bcd$.tm3) do goto _nomedia
rem got media, check if media is erasable
findstr /I "/C:Is erasable" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
for /f %%j in (%temp%\$bcd$.tm3) do goto _iscdrw
rem Some cdr medias do not report "is not erasable" so assuming cdr media
rem if atip "is erasable" is missing...
rem findstr /I "/C:Is not erasable" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
rem for /f %%j in (%temp%\$bcd$.tm3) do goto _iscdr
rem goto _end
goto _iscdr

:_iscdrw
echo BCD : Le CD est un CD-RW, vrifie s'il faut l'effacer
bin\cdrecord.exe dev=%bcd_dev% -toc >%temp%\$bcd$.tmp 2>&1
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	type %temp%\$bcd$.tmp
	goto _abort)
findstr /I "/C:Cannot read TOC header" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
for /f %%j in (%temp%\$bcd$.tm3) do goto _isblank
echo BCD : Effacement du CD-RW
set bcd_tmp=
if not "%bcd_spd%" == "" set bcd_tmp=speed=%bcd_spd%
bin\cdrecord.exe dev=%bcd_dev% %bcd_tmp% -v blank=fast
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	goto _abort)
goto _record
set bcd_tmp=
:_isblank
echo BCD : Le CD est vierge, prt  graver.
goto _record
:_iscdr
echo BCD : Le CD est un CD-R, vrification que le disque est vierge
bin\cdrecord.exe dev=%bcd_dev% -toc >%temp%\$bcd$.tmp 2>&1
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	type %temp%\$bcd$.tmp
	goto _abort)
findstr /I "/C:Cannot read TOC header" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
for /f %%j in (%temp%\$bcd$.tm3) do goto _isblank
echo BCD : Le CD n'est pas vierge, insrez un autre CD pour "%bcd_name%"...
bin\cdrecord.exe dev=%bcd_dev% -eject >nul 2>&1
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	type %temp%\$bcd$.tmp
	goto _abort)
bin\bchoice /c:ca /d:c Appuyez C (ou Entree) pour continuer ou A pour Annuler ?
if errorlevel 1 goto _end
goto _media

:_record
set bcd_tmp=
if not "%bcd_spd%" == "" set bcd_tmp=speed=%bcd_spd%
echo BCD : Gravure du CD-Rom (lance cdrecord.exe)
echo BCD : Arguments; dev=%bcd_dev% %bcd_tmp% -v %bcd_cdr% %temp%\bcd.iso
bin\cdrecord.exe dev=%bcd_dev% %bcd_tmp% -v %bcd_cdr% %temp%\bcd.iso
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	goto _abort)
set bcd_tmp=
echo BCD : Gravure de "%bcd_name%" termine.
goto _end

:_nomedia
echo BCD : Insrez un CD pour "%bcd_name%"...
bin\cdrecord.exe dev=%bcd_dev% -eject >nul 2>&1
if errorlevel 1 (
	echo BCD : cdrecord a retourn une erreur :
	type %temp%\$bcd$.tmp
	goto _abort)
bin\bchoice /c:ca /d:c Appuyez C (ou Entree) pour continuer ou A pour Annuler ?
if errorlevel 1 goto _end
goto _media

:_chkdev
if not "%bcd_dev%" == "" goto :eof
if exist %temp%\$bcd$.tm3 del %temp%\$bcd$.tm3
echo BCD : Recherche des capacits du priphrique %bcd_tmp%
bin\cdrecord.exe dev=%bcd_tmp% -prcap > %temp%\$bcd$.tmp 2>&1
if errorlevel 1 goto :eof
if "%bcd_deb%" == "" goto _chkdev1
echo debug: Capacits du priphrique %bcd_tmp%
type %temp%\$bcd$.tmp
echo debug: Fin des capacits du priphrique
echo debug: Cherche "%*"
:_chkdev1
findstr /L "/C:%*" %temp%\$bcd$.tmp >%temp%\$bcd$.tm3
for /f %%j in (%temp%\$bcd$.tm3) do set bcd_dev=%bcd_tmp%
goto :eof
:_bline
if not "%bcd_deb%" == "" echo debug: cmd=[%bcd_cmd%] arg=[%bcd_arg%] err=[%bcd_err%]
if not "%bcd_err%" == "" goto :eof
if /I "%bcd_cmd%" == "bootfile" (
	set bcd_boot=%bcd_arg%
	echo BCD : Bootfile = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "volumeid" (
	set bcd_volid=%bcd_arg%
	echo BCD : Volumeid = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "volumeset" (
	set bcd_vset=%bcd_arg%
	echo BCD : Volumeset = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "preparer" (
	set bcd_prep=%bcd_arg%
	echo BCD : Preparer = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "publisher" (
	set bcd_publ=%bcd_arg%
	echo BCD : Publisher = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "application" (
	set bcd_appid=%bcd_arg%
	echo BCD : Application = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "system" (
	set bcd_sysid=%bcd_arg%
	echo BCD : System = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "mkisofsargs" (
	set bcd_isofs=%bcd_arg%
	echo BCD : Mkisofsargs = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "cdrecordargs" (
	set bcd_cdr=%bcd_arg%
	echo BCD : Cdrecordargs = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "call" (
	set bcd_call=%bcd_arg%
	echo BCD : Call = "%bcd_arg%"
	goto :eof)
if /I "%bcd_cmd%" == "addpath" (
	set bcd_pth=%bcd_arg%
	echo BCD : Add path = "%bcd_arg%"
	goto :eof)
echo BCD : mot cl inconnu "%bcd_cmd%"
set bcd_err=1
goto :eof
:_bldall
echo BCD : Cr toutes les images de boot !
set bcd_cnt=0
for /d %%i in (cds\*.*) do call :_ball %%i
echo BCD : %bcd_cnt% disque(s) de boot gnr(s).
goto _end
:_ball
if not "%bcd_err%" == "" goto :eof
echo BCD : Traitement du CD "%1"
rem process bootdisk.cfg file
if not exist %1\bootdisk.cfg goto _bdcfg2
echo BCD : Traitement du fichier de configuration de bootdisk "%1\bootdisk.cfg"
set rv=
for /f "eol=# tokens=1,2" %%j in (%1\bootdisk.cfg) do call :_bflopo %1 %%j %%k
if not "%bcd_err%" == "" goto _abort
:_bdcfg2
goto :eof
:_bflopo
if "%bcd_err%" == "1" goto :eof
echo BCD : Cration de l'image de boot "%3"
call bfd.cmd %2 -i %1\files\%3
if "%rv%" == "1" (
	set bcd_err=1
	goto :eof)
set /a bcd_cnt=%bcd_cnt%+1
goto :eof
:_bflop
if "%bcd_err%" == "1" goto :eof
if exist cds\%bcd_name%\files\%2 goto _biext
echo BCD : Image de boot "%2" inexistante, gnrons l !
call bfd.cmd %1 -i cds\%bcd_name%\files\%2
if "%rv%" == "1" set bcd_err=1
goto :eof
:_biext
echo BCD : Image de boot "%2" existe dj, on passe la cration
goto :eof
:_nodir
echo BCD : CD "%bcd_name%" n'existe pas...
echo BCD : Vous devez spcifier un des noms suivants :
for /d %%i in (cds\*.*) do echo %%~ni
goto _end4
:_usage
echo Usage : bcd [-d] [-b] [-s nn] nom
echo         bcd -bab
echo.
echo   nom     : nom du CD  gnrer
echo   -d      : affiche les messages de debug
echo   -b      : ne pas graver (juste crer l'image ISO)
echo   -s nn   : dfinir la vitesse de gravure
echo   -bab    : reconstruit toutes les images disque pour tous les CD
echo             (en utilisant les fichier bootdisk.cfg de chaque CD)
echo.
echo Renvoie la variable d'environment "rv", 0 si succs, 1 si erreur
echo.
echo Ce programme utilise les fichiers suivants (situs dans le rpertoire "bin"):
echo - Mkisofs et Cdrecord par Joerg Schilling (GNU-GPL license). 
echo - Nero Aspi Library (wnaspi32.dll) par Ahead Software AG (free download)
echo - Bart's choice (bchoice.exe) par Bart Lagerweij (Nu2 license). 
goto _end4
:_4nt
echo BFD : Dmarrage impossible avec 4NT! Utilisez l'interprteur standard (cmd.exe)
goto _abort
:_noext
echo BCD : Impossible d'autoriser les extensions.
rem flow into _abort
:_abort
if exist %temp%\bcd.iso (
	echo BCD : Annul, suppression de l'image ISO "%temp%\bcd.iso"
	del %temp%\bcd.iso)
echo BCD : Annul...
echo.
rem set return value to 1
endlocal
set rv=1
pause
goto _end3
:_end
if not exist %temp%\bcd.iso goto _end2
if not "%bcd_noburn%" == "" (
	echo BCD : Gravure dsactive, on ne supprime pas le fichier ISO "%temp%\bcd.iso".
	echo BCD : Vous pouvez graver ce fichier ISO avec votre programme de gravure prfr.)
if not "%bcd_noburn%" == "" goto _end2
if exist %temp%\bcd.iso (
	echo BCD : Suppression de l'image ISO "%temp%\bcd.iso"
	del %temp%\bcd.iso)
:_end2
rem set return value to 0
endlocal
set rv=0
:_end3
if exist %temp%\$bcd$.tm? del %temp%\$bcd$.tm?
:_end4
echo BCD : Sortie avec le code retour %rv%
